<?php

class ZIMB_Auth_Adapter_iSeries implements Zend_Auth_Adapter_Interface {
	protected $_zendDb;
	protected $_tableName;
	protected $_identityColumn;
	protected $_credentialColumn;
	protected $_credentialTreatment;
	protected $_identity;
	protected $_credential;
	protected $_schema;
	protected $_resultRow;
	/**
	 * @return unknown
	 */
	public function get_credential() {
		return $this->_credential;
	}
	
	/**
	 * @return unknown
	 */
	public function get_identity() {
		return $this->_identity;
	}
	
	/**
	 * @param unknown_type $_credential
	 */
	public function setCredential($_credential) {
		$this->_credential = strtoupper($_credential);
		return $this;
	}
	
	/**
	 * @param unknown_type $_identity
	 */
	public function setIdentity($_identity) {
		$this->_identity = strtoupper($_identity);
		return $this;
	}

	public function set_tableName($tableName) {
		$this->_tableName = $tableName;
		return $this;
	}
	public function set_identityColumn($identityColumn) {
		$this->_identityColumn = $identityColumn;
		return $this;
	}
	public function set_credentialColumn($credentialColumn) {
		$this->_credentialColumn = $credentialColumn;
		return $this;
	}
	public function set_credentialTreatment($credentialTreatment) {
		$this->_credentialTreatment = $credentialTreatment;
		return $this;
	}
	public function set_Schema($schema) {
		$this->_schema = $schema;
		return $this;
	}
	/**
	 * 
	 */
	public function __construct(Zend_Db_Adapter_Abstract $zendDb, $schema = null, $tableName = null, $identityColumn = null,
                                $credentialColumn = null, $credentialTreatment = null)
   	{
        	$this->_zendDb = $zendDb;
		if (null !== $schema) {
		    $this->set_Schema($schema);
		}
	
	        if (null !== $tableName) {
	            $this->set_TableName($tableName);
	        }

	        if (null !== $identityColumn) {
	            $this->set_IdentityColumn($identityColumn);
	        }
	
	        if (null !== $credentialColumn) {
	            $this->set_CredentialColumn($credentialColumn);
	        }
	
	        if (null !== $credentialTreatment) {
	            $this->set_CredentialTreatment($credentialTreatment);
	        }
	}
	
	/**
	 * 
	 * @throws Zend_Auth_Adapter_Exception If authentication cannot be performed 
	 * @return Zend_Auth_Result 
	 * @see Zend_Auth_Adapter_Interface::authenticate()
	 */
	public function authenticate() {
		
		$i5= i5_connect("localhost", $this->_identity, $this->_credential);
		if ($i5)
		{
			// We know this is an iseries user.  Now determine if they are authorized
			// to use ZiMB Manager
			
			// Get User Row From ZIMB/USER
			try{
			$sql = "SELECT * FROM $this->_schema.$this->_tableName where $this->_identityColumn = '$this->_identity'";
			$user = $this->_zendDb->fetchRow($sql);
			if ($user)
			{
				// Load row into resultRow
				$this->_resultRow = $user;
				
			
				// 
				$result = new Zend_Auth_Result(Zend_Auth_Result::SUCCESS, $this->_identity);
			}
			else
			{
				$result = new Zend_Auth_Result(Zend_Auth_Result::FAILURE_IDENTITY_NOT_FOUND, "",  array("User access not setup for Zimb Manager"));
				
			}
			}
			catch (Exception $e)
			{
				ZIMB_Base_Utilities::dump($e);
			}
		}
		else 
		{
			$result = new Zend_Auth_Result(Zend_Auth_Result::FAILURE_CREDENTIAL_INVALID, "");
		}
		return $result;	
		
	}
	
	
	
	/**
	 * 
	 */
	function __destruct() {
	
	}
	
	public function getResultRowObject($returnColumns = null, $omitColumns = null)
    	{
	        if (!$this->_resultRow) {
	            return false;
	        }
	
	        $returnObject = new stdClass();
	
	        if (null !== $returnColumns) {
	
	            $availableColumns = array_keys($this->_resultRow);
	            foreach ( (array) $returnColumns as $returnColumn) {
	                if (in_array($returnColumn, $availableColumns)) {
	                    $returnObject->{$returnColumn} = $this->_resultRow[$returnColumn];
	                }
	            }
	            return $returnObject;
	
	        } elseif (null !== $omitColumns) {
	
	            $omitColumns = (array) $omitColumns;
	            foreach ($this->_resultRow as $resultColumn => $resultValue) {
	                if (!in_array($resultColumn, $omitColumns)) {
	                    $returnObject->{$resultColumn} = $resultValue;
	                }
	            }
	            return $returnObject;
	
	        } else {
	
	            foreach ($this->_resultRow as $resultColumn => $resultValue) {
	                $returnObject->{$resultColumn} = $resultValue;
	            }
	            return $returnObject;
	
	        }
	}

	
}

?> 