<?php
class ZIMB_Base_Authorization {
	// Fields
	
	
	
	// Properties
	
	
	
	// Constructors/Destructors
	/**
	 * 
	 */
	function __construct() {
	
	}
	
	/**
	 * 
	 */
	function __destruct() {
	
	}
	
	// Factories
	public static function returnACL($role)
	{
		$acl = new Zend_Acl();
		// Add Role to ACL
		$acl->addRole(new Zend_Acl_Role($role->NAME));
		
		// Load all RIGHTS into Associative Array
		$rightObj = new ZIMB_Base_Right();
		$rightList = $rightObj->fetchAll();
	
		
		// Load All Resources
		$resourceObj = new ZIMB_Base_Resource();
		$resourceList = $resourceObj->fetchAll();
		$resourceArray = array();
		foreach ($resourceList as $resource)
		{
			$resourceArray[$resource->ID] = $resource;
			$acl->add(new Zend_Acl_Resource($resource->NAME));
		}
		
		
		$rightName = "";
		$rightAccessible = false;
		// Get Default Right Description
		$rightsArray = array();
		foreach ($rightList as $right)
		{
			$rightsArray[$right->ID] = $right;
			if ($right->ID == $role->DEFAULTRIGHTID)
			{
				$rightName = $right->DESCRIPTION;
			}	
		}
		
		// Set Default ACL Rights For User to ALL Items
		if ($rightName == "ALL")
		{
			foreach ($rightList as $right)
			{
				if ($right->TYPE == "A")
				{
					$acl->allow($role->NAME, null, $right->DESCRIPTION);
				}
			}
		}
		elseif ($rightName == "DENY")
		{
			$acl->deny($role->NAME, null);
		}
		else
		{
			$acl->allow($role->NAME, null, $rightName);
		}
		
		//TODO: Set ACL Rights for inherited groups, etc. 
		
					
			
		// Load Specific ACL Rights from ACLMAP
		$aclmapObj = new ZIMB_Base_Aclmap();
		$select = $aclmapObj->select()->where("ROLEID = ?", $role->ID);
		$aclmap = $aclmapObj->fetchAll($select);	
			
		if ($aclmap)
		{
			foreach ($aclmap as $rule)
			{
				$currentRight = $rightsArray[$rule->RIGHTID];
				$currentResource = $resourceArray[$rule->RESOURCEID];
				if ($currentRight->TYPE == "A")
				{
					$acl->allow($role->NAME, $currentResource->NAME, $currentRight->DESCRIPTION);
				}
				else
				{
					$acl->deny($role->NAME, $currentResource->NAME, $currentRight->DESCRIPTION);
					//$acl->removeAllow($role->NAME, $currentResource->NAME);
				}
			}
			
		}
		
		// Load Rights for ALWAYS AVAILABLE STUFF
		$acl->allow($role->NAME, 'administrator/Index/authenticate');
		
		
		return $acl;
	}
	
	
	// Methods
	
	
	
}

?>