<?php
class ZIMB_Form
{
	// Fields
	protected $_javascript = "";
	protected $_elements;
	protected $_decorators;
	// Getters/Setters
	
	// Constructors/Destructors
	protected function __construct()
	{
		$this->_javascript = $this->_loadJavascriptString();
	}
	
	
	// Factories
	public static function getNewForm()
	{
		$form = new self();
		return $form;
	}
	// Functions
	protected function createElement($type, $params)
	{
		if (!$this->_elements instanceof ZIMB_Form_ElementList)
		{
			$this->_elements = ZIMB_Form_ElementList::getNewElementList();
			
		}
		$element = ZIMB_Form_Element::getNewElement($type, $params);
		return $element;
	}
	public function renderJavascript()
	{
		return $this->_javascript;
	}	
	public function render()
	{
		$outputString = "";
		if ($this->_elements instanceof ZIMB_Form_ElementList)
		{
			$outputString .= $this->_elements->render();
		}
		return $outputString;
	}
	protected function _loadJavascriptString() 
	{
		// Load Custom Javascript For Form
		$fileParts = explode("_", get_class($this));
		$filename = $fileParts[count($fileParts) - 1];
		
		$path =  ZIMB_Base_Utilities::get_current_files_path($filename.".php");
		
		$fileName =  $path .$filename.".js";
		$fh = fopen($fileName, 'r');
		if ($fh)
		{
			$string = fread($fh, filesize($fileName));
			fclose($fh);
		}
		else
		{
			$string = "ERROR";
		}
		return $string;
	}
		
}
?>