<?php

class ZIMB_Form_Element_Table extends ZIMB_Form_Element 
    { 
    
    	// Fields
		
		//!!!!! Header values have been moved into the "values" array for greater consistency.
    	//protected $_header; //
		
		//!!!!! Elements now hold the rows in order to attempt a greater sense of consistency.
    	//protected $_rows;	// Array of TableRows
    	
    
    	// Properties
     
        public function render() 
        { 
			$attributeString = "";
			if (is_array($this->_value))
			{
			
				foreach ($this->_value as $key => $value)
				{
					$attributeString .= $key . ' = "' . $value . '" ';
				}
			}
            $html = "<table $attributeString>";
            if ($this->_value["header"] && is_array($this->_value["header"]))
            {
            	$html .= "<thead>";
            	foreach ($this->_value["header"] as $header)
            	{	
            		$html .= "<th><span>";
            		$html .= $header;            	
            		$html .= "</span></th>";
            	}
            	$html .= "</thead>";
            }
            
            
        
            if ($this->_elements instanceof ZIMB_Form_ElementList)
            {
				
            	$html .= "<tbody>";
            	foreach ($this->_elements as $row)
            	{
            		$html .= $row->render();
            	}
            	$html .= "</tbody>";
            }
            $html .= "</table>";
            
            return $html;
        } 
        
        public function getValue()
   	 {
    	
    		$value = array();
    		if ($this->rows && is_array($this->rows))
    		{
    			foreach ($this->rows as $row)
    			{
    				$value[$row->getName] = $row->getValue();    		
    			}
    	   	}
    	   	return $value;
  	  }
    } 
    
    